Attribute VB_Name = "RijndaelSetup"
Option Explicit

Private Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function VirtualProtect Lib "kernel32" (lpAddress As Any, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long

Private Const PAGE_EXECUTE_READWRITE As Long = &H40

Public Sub Init_Rijndael()
  Dim i As Long, n As Long, tmp(3) As Long
    
    Logarithmus(0) = -1
    
    Potenz(0) = 1
    Logarithmus(1) = 0
    
    For i = 1 To 254
      Potenz(i) = shl(Potenz(i - 1), 1) Xor Potenz(i - 1)
      
      If Potenz(i) > 255 Then
        Potenz(i) = Potenz(i) Xor &H11B&
      End If
      
      Logarithmus(Potenz(i)) = i
    Next i
    
    For i = 0 To 255
      Substitution(i) = fwd_affine(Inv(i))
      InvSubstitution(i) = Inv(inv_affine(i))
    Next i
    
    rc(0) = 1
    For i = 1 To UBound(rc)
      rc(i) = mul(rc(i - 1), 2)
    Next i
    
    For i = 0 To 255
      tmp(0) = mul(2, CByte(Substitution(i)))
      tmp(1) = Substitution(i)
      tmp(2) = Substitution(i)
      tmp(3) = mul(3, CByte(Substitution(i)))
      
      t(i, 0) = tmp(0) Or shl(tmp(1), 8) Or shl(tmp(2), 16) Or shl(tmp(3), 24)
      t(i, 1) = tmp(3) Or shl(tmp(0), 8) Or shl(tmp(1), 16) Or shl(tmp(2), 24)
      t(i, 2) = tmp(2) Or shl(tmp(3), 8) Or shl(tmp(0), 16) Or shl(tmp(1), 24)
      t(i, 3) = tmp(1) Or shl(tmp(2), 8) Or shl(tmp(3), 16) Or shl(tmp(0), 24)
      
      For n = 0 To 3
        t(i, n + 4) = shl(Substitution(i), n * 8)
      Next n
    Next i
    
    For i = 0 To 255
      tmp(0) = mul(&HE&, CByte(InvSubstitution(i)))
      tmp(1) = mul(&H9&, CByte(InvSubstitution(i)))
      tmp(2) = mul(&HD&, CByte(InvSubstitution(i)))
      tmp(3) = mul(&HB&, CByte(InvSubstitution(i)))
      
      t2(i, 0) = tmp(0) Or shl(tmp(1), 8) Or shl(tmp(2), 16) Or shl(tmp(3), 24)
      t2(i, 1) = tmp(3) Or shl(tmp(0), 8) Or shl(tmp(1), 16) Or shl(tmp(2), 24)
      t2(i, 2) = tmp(2) Or shl(tmp(3), 8) Or shl(tmp(0), 16) Or shl(tmp(1), 24)
      t2(i, 3) = tmp(1) Or shl(tmp(2), 8) Or shl(tmp(3), 16) Or shl(tmp(0), 24)
      
      For n = 0 To 3
        t2(i, n + 4) = shl(InvSubstitution(i), n * 8)
      Next n
    Next i
    
    'ASM Stuff
    ReDim asm_reb(470)
  
    asm_reb(0) = &H53555756: asm_reb(1) = &H14244C8B
    asm_reb(2) = &H1824548B: asm_reb(3) = &H1C247C8B
    asm_reb(4) = &H598B018B: asm_reb(5) = &H33023304
    asm_reb(6) = &H718B045A: asm_reb(7) = &HC698B08
    asm_reb(8) = &H33087233: asm_reb(9) = &H528D0C6A
    asm_reb(10) = &HCEC8310: asm_reb(11) = &H5489C933
    asm_reb(12) = &HD08B0824: asm_reb(13) = &H89243489
    asm_reb(14) = &H8A04246C: asm_reb(15) = &H8F048BCA
    asm_reb(16) = &HEAC1CE8A: asm_reb(17) = &H8FAC8B10
    asm_reb(18) = &H400&: asm_reb(19) = &HB48BCA8A
    asm_reb(20) = &H8008F: asm_reb(21) = &H8BCE8A00
    asm_reb(22) = &H8F9C8BD3: asm_reb(23) = &HC00&
    asm_reb(24) = &H1C33CA8A: asm_reb(25) = &HC1CE8A8F
    asm_reb(26) = &H843310EA: asm_reb(27) = &H4008F
    asm_reb(28) = &H33CA8A00: asm_reb(29) = &H8008FAC
    asm_reb(30) = &HCE8A0000: asm_reb(31) = &H8FB433
    asm_reb(32) = &H8B00000C: asm_reb(33) = &HCA8A2414
    asm_reb(34) = &H8A8F3433: asm_reb(35) = &H10EAC1CE
    asm_reb(36) = &H8F9C33: asm_reb(37) = &H8A000004
    asm_reb(38) = &H8F8433CA: asm_reb(39) = &H800&
    asm_reb(40) = &HAC33CE8A: asm_reb(41) = &HC008F
    asm_reb(42) = &H24548B00: asm_reb(43) = &H33CA8A04
    asm_reb(44) = &HCE8A8F2C: asm_reb(45) = &H3310EAC1
    asm_reb(46) = &H4008FB4: asm_reb(47) = &HCA8A0000
    asm_reb(48) = &H8F9C33: asm_reb(49) = &H8A000008
    asm_reb(50) = &H8F8433CE: asm_reb(51) = &HC00&
    asm_reb(52) = &H824548B: asm_reb(53) = &H5A330233
    asm_reb(54) = &H8723304: asm_reb(55) = &H8D0C6A33
    asm_reb(56) = &H54891052: asm_reb(57) = &HD08B0824
    asm_reb(58) = &H89243489: asm_reb(59) = &H8A04246C
    asm_reb(60) = &H8F048BCA: asm_reb(61) = &HEAC1CE8A
    asm_reb(62) = &H8FAC8B10: asm_reb(63) = &H400&
    asm_reb(64) = &HB48BCA8A: asm_reb(65) = &H8008F
    asm_reb(66) = &H8BCE8A00: asm_reb(67) = &H8F9C8BD3
    asm_reb(68) = &HC00&: asm_reb(69) = &H1C33CA8A
    asm_reb(70) = &HC1CE8A8F: asm_reb(71) = &H843310EA
    asm_reb(72) = &H4008F: asm_reb(73) = &H33CA8A00
    asm_reb(74) = &H8008FAC: asm_reb(75) = &HCE8A0000
    asm_reb(76) = &H8FB433: asm_reb(77) = &H8B00000C
    asm_reb(78) = &HCA8A2414: asm_reb(79) = &H8A8F3433
    asm_reb(80) = &H10EAC1CE: asm_reb(81) = &H8F9C33
    asm_reb(82) = &H8A000004: asm_reb(83) = &H8F8433CA
    asm_reb(84) = &H800&: asm_reb(85) = &HAC33CE8A
    asm_reb(86) = &HC008F: asm_reb(87) = &H24548B00
    asm_reb(88) = &H33CA8A04: asm_reb(89) = &HCE8A8F2C
    asm_reb(90) = &H3310EAC1: asm_reb(91) = &H4008FB4
    asm_reb(92) = &HCA8A0000: asm_reb(93) = &H8F9C33
    asm_reb(94) = &H8A000008: asm_reb(95) = &H8F8433CE
    asm_reb(96) = &HC00&: asm_reb(97) = &H824548B
    asm_reb(98) = &H5A330233: asm_reb(99) = &H8723304
    asm_reb(100) = &H8D0C6A33: asm_reb(101) = &H54891052
    asm_reb(102) = &HD08B0824: asm_reb(103) = &H89243489
    asm_reb(104) = &H8A04246C: asm_reb(105) = &H8F048BCA
    asm_reb(106) = &HEAC1CE8A: asm_reb(107) = &H8FAC8B10
    asm_reb(108) = &H400&: asm_reb(109) = &HB48BCA8A
    asm_reb(110) = &H8008F: asm_reb(111) = &H8BCE8A00
    asm_reb(112) = &H8F9C8BD3: asm_reb(113) = &HC00&
    asm_reb(114) = &H1C33CA8A: asm_reb(115) = &HC1CE8A8F
    asm_reb(116) = &H843310EA: asm_reb(117) = &H4008F
    asm_reb(118) = &H33CA8A00: asm_reb(119) = &H8008FAC
    asm_reb(120) = &HCE8A0000: asm_reb(121) = &H8FB433
    asm_reb(122) = &H8B00000C: asm_reb(123) = &HCA8A2414
    asm_reb(124) = &H8A8F3433: asm_reb(125) = &H10EAC1CE
    asm_reb(126) = &H8F9C33: asm_reb(127) = &H8A000004
    asm_reb(128) = &H8F8433CA: asm_reb(129) = &H800&
    asm_reb(130) = &HAC33CE8A: asm_reb(131) = &HC008F
    asm_reb(132) = &H24548B00: asm_reb(133) = &H33CA8A04
    asm_reb(134) = &HCE8A8F2C: asm_reb(135) = &H3310EAC1
    asm_reb(136) = &H4008FB4: asm_reb(137) = &HCA8A0000
    asm_reb(138) = &H8F9C33: asm_reb(139) = &H8A000008
    asm_reb(140) = &H8F8433CE: asm_reb(141) = &HC00&
    asm_reb(142) = &H824548B: asm_reb(143) = &H5A330233
    asm_reb(144) = &H8723304: asm_reb(145) = &H8D0C6A33
    asm_reb(146) = &H54891052: asm_reb(147) = &HD08B0824
    asm_reb(148) = &H89243489: asm_reb(149) = &H8A04246C
    asm_reb(150) = &H8F048BCA: asm_reb(151) = &HEAC1CE8A
    asm_reb(152) = &H8FAC8B10: asm_reb(153) = &H400&
    asm_reb(154) = &HB48BCA8A: asm_reb(155) = &H8008F
    asm_reb(156) = &H8BCE8A00: asm_reb(157) = &H8F9C8BD3
    asm_reb(158) = &HC00&: asm_reb(159) = &H1C33CA8A
    asm_reb(160) = &HC1CE8A8F: asm_reb(161) = &H843310EA
    asm_reb(162) = &H4008F: asm_reb(163) = &H33CA8A00
    asm_reb(164) = &H8008FAC: asm_reb(165) = &HCE8A0000
    asm_reb(166) = &H8FB433: asm_reb(167) = &H8B00000C
    asm_reb(168) = &HCA8A2414: asm_reb(169) = &H8A8F3433
    asm_reb(170) = &H10EAC1CE: asm_reb(171) = &H8F9C33
    asm_reb(172) = &H8A000004: asm_reb(173) = &H8F8433CA
    asm_reb(174) = &H800&: asm_reb(175) = &HAC33CE8A
    asm_reb(176) = &HC008F: asm_reb(177) = &H24548B00
    asm_reb(178) = &H33CA8A04: asm_reb(179) = &HCE8A8F2C
    asm_reb(180) = &H3310EAC1: asm_reb(181) = &H4008FB4
    asm_reb(182) = &HCA8A0000: asm_reb(183) = &H8F9C33
    asm_reb(184) = &H8A000008: asm_reb(185) = &H8F8433CE
    asm_reb(186) = &HC00&: asm_reb(187) = &H824548B
    asm_reb(188) = &H5A330233: asm_reb(189) = &H8723304
    asm_reb(190) = &H8D0C6A33: asm_reb(191) = &H54891052
    asm_reb(192) = &HD08B0824: asm_reb(193) = &H89243489
    asm_reb(194) = &H8A04246C: asm_reb(195) = &H8F048BCA
    asm_reb(196) = &HEAC1CE8A: asm_reb(197) = &H8FAC8B10
    asm_reb(198) = &H400&: asm_reb(199) = &HB48BCA8A
    asm_reb(200) = &H8008F: asm_reb(201) = &H8BCE8A00
    asm_reb(202) = &H8F9C8BD3: asm_reb(203) = &HC00&
    asm_reb(204) = &H1C33CA8A: asm_reb(205) = &HC1CE8A8F
    asm_reb(206) = &H843310EA: asm_reb(207) = &H4008F
    asm_reb(208) = &H33CA8A00: asm_reb(209) = &H8008FAC
    asm_reb(210) = &HCE8A0000: asm_reb(211) = &H8FB433
    asm_reb(212) = &H8B00000C: asm_reb(213) = &HCA8A2414
    asm_reb(214) = &H8A8F3433: asm_reb(215) = &H10EAC1CE
    asm_reb(216) = &H8F9C33: asm_reb(217) = &H8A000004
    asm_reb(218) = &H8F8433CA: asm_reb(219) = &H800&
    asm_reb(220) = &HAC33CE8A: asm_reb(221) = &HC008F
    asm_reb(222) = &H24548B00: asm_reb(223) = &H33CA8A04
    asm_reb(224) = &HCE8A8F2C: asm_reb(225) = &H3310EAC1
    asm_reb(226) = &H4008FB4: asm_reb(227) = &HCA8A0000
    asm_reb(228) = &H8F9C33: asm_reb(229) = &H8A000008
    asm_reb(230) = &H8F8433CE: asm_reb(231) = &HC00&
    asm_reb(232) = &H824548B: asm_reb(233) = &H5A330233
    asm_reb(234) = &H8723304: asm_reb(235) = &H8D0C6A33
    asm_reb(236) = &H54891052: asm_reb(237) = &HD08B0824
    asm_reb(238) = &H89243489: asm_reb(239) = &H8A04246C
    asm_reb(240) = &H8F048BCA: asm_reb(241) = &HEAC1CE8A
    asm_reb(242) = &H8FAC8B10: asm_reb(243) = &H400&
    asm_reb(244) = &HB48BCA8A: asm_reb(245) = &H8008F
    asm_reb(246) = &H8BCE8A00: asm_reb(247) = &H8F9C8BD3
    asm_reb(248) = &HC00&: asm_reb(249) = &H1C33CA8A
    asm_reb(250) = &HC1CE8A8F: asm_reb(251) = &H843310EA
    asm_reb(252) = &H4008F: asm_reb(253) = &H33CA8A00
    asm_reb(254) = &H8008FAC: asm_reb(255) = &HCE8A0000
    asm_reb(256) = &H8FB433: asm_reb(257) = &H8B00000C
    asm_reb(258) = &HCA8A2414: asm_reb(259) = &H8A8F3433
    asm_reb(260) = &H10EAC1CE: asm_reb(261) = &H8F9C33
    asm_reb(262) = &H8A000004: asm_reb(263) = &H8F8433CA
    asm_reb(264) = &H800&: asm_reb(265) = &HAC33CE8A
    asm_reb(266) = &HC008F: asm_reb(267) = &H24548B00
    asm_reb(268) = &H33CA8A04: asm_reb(269) = &HCE8A8F2C
    asm_reb(270) = &H3310EAC1: asm_reb(271) = &H4008FB4
    asm_reb(272) = &HCA8A0000: asm_reb(273) = &H8F9C33
    asm_reb(274) = &H8A000008: asm_reb(275) = &H8F8433CE
    asm_reb(276) = &HC00&: asm_reb(277) = &H824548B
    asm_reb(278) = &H5A330233: asm_reb(279) = &H8723304
    asm_reb(280) = &H8D0C6A33: asm_reb(281) = &H54891052
    asm_reb(282) = &HD08B0824: asm_reb(283) = &H89243489
    asm_reb(284) = &H8A04246C: asm_reb(285) = &H8F048BCA
    asm_reb(286) = &HEAC1CE8A: asm_reb(287) = &H8FAC8B10
    asm_reb(288) = &H400&: asm_reb(289) = &HB48BCA8A
    asm_reb(290) = &H8008F: asm_reb(291) = &H8BCE8A00
    asm_reb(292) = &H8F9C8BD3: asm_reb(293) = &HC00&
    asm_reb(294) = &H1C33CA8A: asm_reb(295) = &HC1CE8A8F
    asm_reb(296) = &H843310EA: asm_reb(297) = &H4008F
    asm_reb(298) = &H33CA8A00: asm_reb(299) = &H8008FAC
    asm_reb(300) = &HCE8A0000: asm_reb(301) = &H8FB433
    asm_reb(302) = &H8B00000C: asm_reb(303) = &HCA8A2414
    asm_reb(304) = &H8A8F3433: asm_reb(305) = &H10EAC1CE
    asm_reb(306) = &H8F9C33: asm_reb(307) = &H8A000004
    asm_reb(308) = &H8F8433CA: asm_reb(309) = &H800&
    asm_reb(310) = &HAC33CE8A: asm_reb(311) = &HC008F
    asm_reb(312) = &H24548B00: asm_reb(313) = &H33CA8A04
    asm_reb(314) = &HCE8A8F2C: asm_reb(315) = &H3310EAC1
    asm_reb(316) = &H4008FB4: asm_reb(317) = &HCA8A0000
    asm_reb(318) = &H8F9C33: asm_reb(319) = &H8A000008
    asm_reb(320) = &H8F8433CE: asm_reb(321) = &HC00&
    asm_reb(322) = &H824548B: asm_reb(323) = &H5A330233
    asm_reb(324) = &H8723304: asm_reb(325) = &H8D0C6A33
    asm_reb(326) = &H54891052: asm_reb(327) = &HD08B0824
    asm_reb(328) = &H89243489: asm_reb(329) = &H8A04246C
    asm_reb(330) = &H8F048BCA: asm_reb(331) = &HEAC1CE8A
    asm_reb(332) = &H8FAC8B10: asm_reb(333) = &H400&
    asm_reb(334) = &HB48BCA8A: asm_reb(335) = &H8008F
    asm_reb(336) = &H8BCE8A00: asm_reb(337) = &H8F9C8BD3
    asm_reb(338) = &HC00&: asm_reb(339) = &H1C33CA8A
    asm_reb(340) = &HC1CE8A8F: asm_reb(341) = &H843310EA
    asm_reb(342) = &H4008F: asm_reb(343) = &H33CA8A00
    asm_reb(344) = &H8008FAC: asm_reb(345) = &HCE8A0000
    asm_reb(346) = &H8FB433: asm_reb(347) = &H8B00000C
    asm_reb(348) = &HCA8A2414: asm_reb(349) = &H8A8F3433
    asm_reb(350) = &H10EAC1CE: asm_reb(351) = &H8F9C33
    asm_reb(352) = &H8A000004: asm_reb(353) = &H8F8433CA
    asm_reb(354) = &H800&: asm_reb(355) = &HAC33CE8A
    asm_reb(356) = &HC008F: asm_reb(357) = &H24548B00
    asm_reb(358) = &H33CA8A04: asm_reb(359) = &HCE8A8F2C
    asm_reb(360) = &H3310EAC1: asm_reb(361) = &H4008FB4
    asm_reb(362) = &HCA8A0000: asm_reb(363) = &H8F9C33
    asm_reb(364) = &H8A000008: asm_reb(365) = &H8F8433CE
    asm_reb(366) = &HC00&: asm_reb(367) = &H824548B
    asm_reb(368) = &H5A330233: asm_reb(369) = &H8723304
    asm_reb(370) = &H8D0C6A33: asm_reb(371) = &H54891052
    asm_reb(372) = &HD08B0824: asm_reb(373) = &H89243489
    asm_reb(374) = &H8A04246C: asm_reb(375) = &H8F048BCA
    asm_reb(376) = &HEAC1CE8A: asm_reb(377) = &H8FAC8B10
    asm_reb(378) = &H400&: asm_reb(379) = &HB48BCA8A
    asm_reb(380) = &H8008F: asm_reb(381) = &H8BCE8A00
    asm_reb(382) = &H8F9C8BD3: asm_reb(383) = &HC00&
    asm_reb(384) = &H1C33CA8A: asm_reb(385) = &HC1CE8A8F
    asm_reb(386) = &H843310EA: asm_reb(387) = &H4008F
    asm_reb(388) = &H33CA8A00: asm_reb(389) = &H8008FAC
    asm_reb(390) = &HCE8A0000: asm_reb(391) = &H8FB433
    asm_reb(392) = &H8B00000C: asm_reb(393) = &HCA8A2414
    asm_reb(394) = &H8A8F3433: asm_reb(395) = &H10EAC1CE
    asm_reb(396) = &H8F9C33: asm_reb(397) = &H8A000004
    asm_reb(398) = &H8F8433CA: asm_reb(399) = &H800&
    asm_reb(400) = &HAC33CE8A: asm_reb(401) = &HC008F
    asm_reb(402) = &H24548B00: asm_reb(403) = &H33CA8A04
    asm_reb(404) = &HCE8A8F2C: asm_reb(405) = &H3310EAC1
    asm_reb(406) = &H4008FB4: asm_reb(407) = &HCA8A0000
    asm_reb(408) = &H8F9C33: asm_reb(409) = &H8A000008
    asm_reb(410) = &H8F8433CE: asm_reb(411) = &HC00&
    asm_reb(412) = &H824548B: asm_reb(413) = &H5A330233
    asm_reb(414) = &H8723304: asm_reb(415) = &H8D0C6A33
    asm_reb(416) = &H54891052: asm_reb(417) = &HBF8D0824
    asm_reb(418) = &H1000&: asm_reb(419) = &H3489D08B
    asm_reb(420) = &H246C8924: asm_reb(421) = &H8BCA8A04
    asm_reb(422) = &HCE8A8F04: asm_reb(423) = &H8B10EAC1
    asm_reb(424) = &H4008FAC: asm_reb(425) = &HCA8A0000
    asm_reb(426) = &H8FB48B: asm_reb(427) = &H8A000008
    asm_reb(428) = &H8BD38BCE: asm_reb(429) = &HC008F9C
    asm_reb(430) = &HCA8A0000: asm_reb(431) = &H8A8F1C33
    asm_reb(432) = &H10EAC1CE: asm_reb(433) = &H8F8433
    asm_reb(434) = &H8A000004: asm_reb(435) = &H8FAC33CA
    asm_reb(436) = &H800&: asm_reb(437) = &HB433CE8A
    asm_reb(438) = &HC008F: asm_reb(439) = &H24148B00
    asm_reb(440) = &H3433CA8A: asm_reb(441) = &HC1CE8A8F
    asm_reb(442) = &H9C3310EA: asm_reb(443) = &H4008F
    asm_reb(444) = &H33CA8A00: asm_reb(445) = &H8008F84
    asm_reb(446) = &HCE8A0000: asm_reb(447) = &H8FAC33
    asm_reb(448) = &H8B00000C: asm_reb(449) = &H8A042454
    asm_reb(450) = &H8F2C33CA: asm_reb(451) = &HEAC1CE8A
    asm_reb(452) = &H8FB43310: asm_reb(453) = &H400&
    asm_reb(454) = &H9C33CA8A: asm_reb(455) = &H8008F
    asm_reb(456) = &H33CE8A00: asm_reb(457) = &HC008F84
    asm_reb(458) = &H548B0000: asm_reb(459) = &H2330824
    asm_reb(460) = &H33045A33: asm_reb(461) = &H6A330872
    asm_reb(462) = &H10528D0C: asm_reb(463) = &H8245489
    asm_reb(464) = &H8B0CC483: asm_reb(465) = &H8914244C
    asm_reb(466) = &H4598901: asm_reb(467) = &H89087189
    asm_reb(468) = &H5D5B0C69: asm_reb(469) = &HC0335E5F
    asm_reb(470) = &H10C2&
    
    ReDim asm_deb(470)
    asm_deb(0) = &H53555756: asm_deb(1) = &H14244C8B
    asm_deb(2) = &H1824548B: asm_deb(3) = &H1C247C8B
    asm_deb(4) = &H598B018B: asm_deb(5) = &H33023304
    asm_deb(6) = &H718B045A: asm_deb(7) = &HC698B08
    asm_deb(8) = &H33087233: asm_deb(9) = &H528D0C6A
    asm_deb(10) = &HCEC8310: asm_deb(11) = &H5489C933
    asm_deb(12) = &HD08B0824: asm_deb(13) = &H89241C89
    asm_deb(14) = &H8A042474: asm_deb(15) = &H8F048BCA
    asm_deb(16) = &HEAC1CE8A: asm_deb(17) = &H8F9C8B10
    asm_deb(18) = &H400&: asm_deb(19) = &HB48BCA8A
    asm_deb(20) = &H8008F: asm_deb(21) = &H8BCE8A00
    asm_deb(22) = &H8FAC8BD5: asm_deb(23) = &HC00&
    asm_deb(24) = &H2C33CA8A: asm_deb(25) = &HC1CE8A8F
    asm_deb(26) = &H843310EA: asm_deb(27) = &H4008F
    asm_deb(28) = &H33CA8A00: asm_deb(29) = &H8008F9C
    asm_deb(30) = &HCE8A0000: asm_deb(31) = &H8FB433
    asm_deb(32) = &H8B00000C: asm_deb(33) = &HCA8A2414
    asm_deb(34) = &H8A8F1C33: asm_deb(35) = &H10EAC1CE
    asm_deb(36) = &H8FB433: asm_deb(37) = &H8A000004
    asm_deb(38) = &H8FAC33CA: asm_deb(39) = &H800&
    asm_deb(40) = &H8433CE8A: asm_deb(41) = &HC008F
    asm_deb(42) = &H24548B00: asm_deb(43) = &H33CA8A04
    asm_deb(44) = &HCE8A8F34: asm_deb(45) = &H3310EAC1
    asm_deb(46) = &H4008FAC: asm_deb(47) = &HCA8A0000
    asm_deb(48) = &H8F8433: asm_deb(49) = &H8A000008
    asm_deb(50) = &H8F9C33CE: asm_deb(51) = &HC00&
    asm_deb(52) = &H824548B: asm_deb(53) = &H5A330233
    asm_deb(54) = &H8723304: asm_deb(55) = &H8D0C6A33
    asm_deb(56) = &H54891052: asm_deb(57) = &HD08B0824
    asm_deb(58) = &H89241C89: asm_deb(59) = &H8A042474
    asm_deb(60) = &H8F048BCA: asm_deb(61) = &HEAC1CE8A
    asm_deb(62) = &H8F9C8B10: asm_deb(63) = &H400&
    asm_deb(64) = &HB48BCA8A: asm_deb(65) = &H8008F
    asm_deb(66) = &H8BCE8A00: asm_deb(67) = &H8FAC8BD5
    asm_deb(68) = &HC00&: asm_deb(69) = &H2C33CA8A
    asm_deb(70) = &HC1CE8A8F: asm_deb(71) = &H843310EA
    asm_deb(72) = &H4008F: asm_deb(73) = &H33CA8A00
    asm_deb(74) = &H8008F9C: asm_deb(75) = &HCE8A0000
    asm_deb(76) = &H8FB433: asm_deb(77) = &H8B00000C
    asm_deb(78) = &HCA8A2414: asm_deb(79) = &H8A8F1C33
    asm_deb(80) = &H10EAC1CE: asm_deb(81) = &H8FB433
    asm_deb(82) = &H8A000004: asm_deb(83) = &H8FAC33CA
    asm_deb(84) = &H800&: asm_deb(85) = &H8433CE8A
    asm_deb(86) = &HC008F: asm_deb(87) = &H24548B00
    asm_deb(88) = &H33CA8A04: asm_deb(89) = &HCE8A8F34
    asm_deb(90) = &H3310EAC1: asm_deb(91) = &H4008FAC
    asm_deb(92) = &HCA8A0000: asm_deb(93) = &H8F8433
    asm_deb(94) = &H8A000008: asm_deb(95) = &H8F9C33CE
    asm_deb(96) = &HC00&: asm_deb(97) = &H824548B
    asm_deb(98) = &H5A330233: asm_deb(99) = &H8723304
    asm_deb(100) = &H8D0C6A33: asm_deb(101) = &H54891052
    asm_deb(102) = &HD08B0824: asm_deb(103) = &H89241C89
    asm_deb(104) = &H8A042474: asm_deb(105) = &H8F048BCA
    asm_deb(106) = &HEAC1CE8A: asm_deb(107) = &H8F9C8B10
    asm_deb(108) = &H400&: asm_deb(109) = &HB48BCA8A
    asm_deb(110) = &H8008F: asm_deb(111) = &H8BCE8A00
    asm_deb(112) = &H8FAC8BD5: asm_deb(113) = &HC00&
    asm_deb(114) = &H2C33CA8A: asm_deb(115) = &HC1CE8A8F
    asm_deb(116) = &H843310EA: asm_deb(117) = &H4008F
    asm_deb(118) = &H33CA8A00: asm_deb(119) = &H8008F9C
    asm_deb(120) = &HCE8A0000: asm_deb(121) = &H8FB433
    asm_deb(122) = &H8B00000C: asm_deb(123) = &HCA8A2414
    asm_deb(124) = &H8A8F1C33: asm_deb(125) = &H10EAC1CE
    asm_deb(126) = &H8FB433: asm_deb(127) = &H8A000004
    asm_deb(128) = &H8FAC33CA: asm_deb(129) = &H800&
    asm_deb(130) = &H8433CE8A: asm_deb(131) = &HC008F
    asm_deb(132) = &H24548B00: asm_deb(133) = &H33CA8A04
    asm_deb(134) = &HCE8A8F34: asm_deb(135) = &H3310EAC1
    asm_deb(136) = &H4008FAC: asm_deb(137) = &HCA8A0000
    asm_deb(138) = &H8F8433: asm_deb(139) = &H8A000008
    asm_deb(140) = &H8F9C33CE: asm_deb(141) = &HC00&
    asm_deb(142) = &H824548B: asm_deb(143) = &H5A330233
    asm_deb(144) = &H8723304: asm_deb(145) = &H8D0C6A33
    asm_deb(146) = &H54891052: asm_deb(147) = &HD08B0824
    asm_deb(148) = &H89241C89: asm_deb(149) = &H8A042474
    asm_deb(150) = &H8F048BCA: asm_deb(151) = &HEAC1CE8A
    asm_deb(152) = &H8F9C8B10: asm_deb(153) = &H400&
    asm_deb(154) = &HB48BCA8A: asm_deb(155) = &H8008F
    asm_deb(156) = &H8BCE8A00: asm_deb(157) = &H8FAC8BD5
    asm_deb(158) = &HC00&: asm_deb(159) = &H2C33CA8A
    asm_deb(160) = &HC1CE8A8F: asm_deb(161) = &H843310EA
    asm_deb(162) = &H4008F: asm_deb(163) = &H33CA8A00
    asm_deb(164) = &H8008F9C: asm_deb(165) = &HCE8A0000
    asm_deb(166) = &H8FB433: asm_deb(167) = &H8B00000C
    asm_deb(168) = &HCA8A2414: asm_deb(169) = &H8A8F1C33
    asm_deb(170) = &H10EAC1CE: asm_deb(171) = &H8FB433
    asm_deb(172) = &H8A000004: asm_deb(173) = &H8FAC33CA
    asm_deb(174) = &H800&: asm_deb(175) = &H8433CE8A
    asm_deb(176) = &HC008F: asm_deb(177) = &H24548B00
    asm_deb(178) = &H33CA8A04: asm_deb(179) = &HCE8A8F34
    asm_deb(180) = &H3310EAC1: asm_deb(181) = &H4008FAC
    asm_deb(182) = &HCA8A0000: asm_deb(183) = &H8F8433
    asm_deb(184) = &H8A000008: asm_deb(185) = &H8F9C33CE
    asm_deb(186) = &HC00&: asm_deb(187) = &H824548B
    asm_deb(188) = &H5A330233: asm_deb(189) = &H8723304
    asm_deb(190) = &H8D0C6A33: asm_deb(191) = &H54891052
    asm_deb(192) = &HD08B0824: asm_deb(193) = &H89241C89
    asm_deb(194) = &H8A042474: asm_deb(195) = &H8F048BCA
    asm_deb(196) = &HEAC1CE8A: asm_deb(197) = &H8F9C8B10
    asm_deb(198) = &H400&: asm_deb(199) = &HB48BCA8A
    asm_deb(200) = &H8008F: asm_deb(201) = &H8BCE8A00
    asm_deb(202) = &H8FAC8BD5: asm_deb(203) = &HC00&
    asm_deb(204) = &H2C33CA8A: asm_deb(205) = &HC1CE8A8F
    asm_deb(206) = &H843310EA: asm_deb(207) = &H4008F
    asm_deb(208) = &H33CA8A00: asm_deb(209) = &H8008F9C
    asm_deb(210) = &HCE8A0000: asm_deb(211) = &H8FB433
    asm_deb(212) = &H8B00000C: asm_deb(213) = &HCA8A2414
    asm_deb(214) = &H8A8F1C33: asm_deb(215) = &H10EAC1CE
    asm_deb(216) = &H8FB433: asm_deb(217) = &H8A000004
    asm_deb(218) = &H8FAC33CA: asm_deb(219) = &H800&
    asm_deb(220) = &H8433CE8A: asm_deb(221) = &HC008F
    asm_deb(222) = &H24548B00: asm_deb(223) = &H33CA8A04
    asm_deb(224) = &HCE8A8F34: asm_deb(225) = &H3310EAC1
    asm_deb(226) = &H4008FAC: asm_deb(227) = &HCA8A0000
    asm_deb(228) = &H8F8433: asm_deb(229) = &H8A000008
    asm_deb(230) = &H8F9C33CE: asm_deb(231) = &HC00&
    asm_deb(232) = &H824548B: asm_deb(233) = &H5A330233
    asm_deb(234) = &H8723304: asm_deb(235) = &H8D0C6A33
    asm_deb(236) = &H54891052: asm_deb(237) = &HD08B0824
    asm_deb(238) = &H89241C89: asm_deb(239) = &H8A042474
    asm_deb(240) = &H8F048BCA: asm_deb(241) = &HEAC1CE8A
    asm_deb(242) = &H8F9C8B10: asm_deb(243) = &H400&
    asm_deb(244) = &HB48BCA8A: asm_deb(245) = &H8008F
    asm_deb(246) = &H8BCE8A00: asm_deb(247) = &H8FAC8BD5
    asm_deb(248) = &HC00&: asm_deb(249) = &H2C33CA8A
    asm_deb(250) = &HC1CE8A8F: asm_deb(251) = &H843310EA
    asm_deb(252) = &H4008F: asm_deb(253) = &H33CA8A00
    asm_deb(254) = &H8008F9C: asm_deb(255) = &HCE8A0000
    asm_deb(256) = &H8FB433: asm_deb(257) = &H8B00000C
    asm_deb(258) = &HCA8A2414: asm_deb(259) = &H8A8F1C33
    asm_deb(260) = &H10EAC1CE: asm_deb(261) = &H8FB433
    asm_deb(262) = &H8A000004: asm_deb(263) = &H8FAC33CA
    asm_deb(264) = &H800&: asm_deb(265) = &H8433CE8A
    asm_deb(266) = &HC008F: asm_deb(267) = &H24548B00
    asm_deb(268) = &H33CA8A04: asm_deb(269) = &HCE8A8F34
    asm_deb(270) = &H3310EAC1: asm_deb(271) = &H4008FAC
    asm_deb(272) = &HCA8A0000: asm_deb(273) = &H8F8433
    asm_deb(274) = &H8A000008: asm_deb(275) = &H8F9C33CE
    asm_deb(276) = &HC00&: asm_deb(277) = &H824548B
    asm_deb(278) = &H5A330233: asm_deb(279) = &H8723304
    asm_deb(280) = &H8D0C6A33: asm_deb(281) = &H54891052
    asm_deb(282) = &HD08B0824: asm_deb(283) = &H89241C89
    asm_deb(284) = &H8A042474: asm_deb(285) = &H8F048BCA
    asm_deb(286) = &HEAC1CE8A: asm_deb(287) = &H8F9C8B10
    asm_deb(288) = &H400&: asm_deb(289) = &HB48BCA8A
    asm_deb(290) = &H8008F: asm_deb(291) = &H8BCE8A00
    asm_deb(292) = &H8FAC8BD5: asm_deb(293) = &HC00&
    asm_deb(294) = &H2C33CA8A: asm_deb(295) = &HC1CE8A8F
    asm_deb(296) = &H843310EA: asm_deb(297) = &H4008F
    asm_deb(298) = &H33CA8A00: asm_deb(299) = &H8008F9C
    asm_deb(300) = &HCE8A0000: asm_deb(301) = &H8FB433
    asm_deb(302) = &H8B00000C: asm_deb(303) = &HCA8A2414
    asm_deb(304) = &H8A8F1C33: asm_deb(305) = &H10EAC1CE
    asm_deb(306) = &H8FB433: asm_deb(307) = &H8A000004
    asm_deb(308) = &H8FAC33CA: asm_deb(309) = &H800&
    asm_deb(310) = &H8433CE8A: asm_deb(311) = &HC008F
    asm_deb(312) = &H24548B00: asm_deb(313) = &H33CA8A04
    asm_deb(314) = &HCE8A8F34: asm_deb(315) = &H3310EAC1
    asm_deb(316) = &H4008FAC: asm_deb(317) = &HCA8A0000
    asm_deb(318) = &H8F8433: asm_deb(319) = &H8A000008
    asm_deb(320) = &H8F9C33CE: asm_deb(321) = &HC00&
    asm_deb(322) = &H824548B: asm_deb(323) = &H5A330233
    asm_deb(324) = &H8723304: asm_deb(325) = &H8D0C6A33
    asm_deb(326) = &H54891052: asm_deb(327) = &HD08B0824
    asm_deb(328) = &H89241C89: asm_deb(329) = &H8A042474
    asm_deb(330) = &H8F048BCA: asm_deb(331) = &HEAC1CE8A
    asm_deb(332) = &H8F9C8B10: asm_deb(333) = &H400&
    asm_deb(334) = &HB48BCA8A: asm_deb(335) = &H8008F
    asm_deb(336) = &H8BCE8A00: asm_deb(337) = &H8FAC8BD5
    asm_deb(338) = &HC00&: asm_deb(339) = &H2C33CA8A
    asm_deb(340) = &HC1CE8A8F: asm_deb(341) = &H843310EA
    asm_deb(342) = &H4008F: asm_deb(343) = &H33CA8A00
    asm_deb(344) = &H8008F9C: asm_deb(345) = &HCE8A0000
    asm_deb(346) = &H8FB433: asm_deb(347) = &H8B00000C
    asm_deb(348) = &HCA8A2414: asm_deb(349) = &H8A8F1C33
    asm_deb(350) = &H10EAC1CE: asm_deb(351) = &H8FB433
    asm_deb(352) = &H8A000004: asm_deb(353) = &H8FAC33CA
    asm_deb(354) = &H800&: asm_deb(355) = &H8433CE8A
    asm_deb(356) = &HC008F: asm_deb(357) = &H24548B00
    asm_deb(358) = &H33CA8A04: asm_deb(359) = &HCE8A8F34
    asm_deb(360) = &H3310EAC1: asm_deb(361) = &H4008FAC
    asm_deb(362) = &HCA8A0000: asm_deb(363) = &H8F8433
    asm_deb(364) = &H8A000008: asm_deb(365) = &H8F9C33CE
    asm_deb(366) = &HC00&: asm_deb(367) = &H824548B
    asm_deb(368) = &H5A330233: asm_deb(369) = &H8723304
    asm_deb(370) = &H8D0C6A33: asm_deb(371) = &H54891052
    asm_deb(372) = &HD08B0824: asm_deb(373) = &H89241C89
    asm_deb(374) = &H8A042474: asm_deb(375) = &H8F048BCA
    asm_deb(376) = &HEAC1CE8A: asm_deb(377) = &H8F9C8B10
    asm_deb(378) = &H400&: asm_deb(379) = &HB48BCA8A
    asm_deb(380) = &H8008F: asm_deb(381) = &H8BCE8A00
    asm_deb(382) = &H8FAC8BD5: asm_deb(383) = &HC00&
    asm_deb(384) = &H2C33CA8A: asm_deb(385) = &HC1CE8A8F
    asm_deb(386) = &H843310EA: asm_deb(387) = &H4008F
    asm_deb(388) = &H33CA8A00: asm_deb(389) = &H8008F9C
    asm_deb(390) = &HCE8A0000: asm_deb(391) = &H8FB433
    asm_deb(392) = &H8B00000C: asm_deb(393) = &HCA8A2414
    asm_deb(394) = &H8A8F1C33: asm_deb(395) = &H10EAC1CE
    asm_deb(396) = &H8FB433: asm_deb(397) = &H8A000004
    asm_deb(398) = &H8FAC33CA: asm_deb(399) = &H800&
    asm_deb(400) = &H8433CE8A: asm_deb(401) = &HC008F
    asm_deb(402) = &H24548B00: asm_deb(403) = &H33CA8A04
    asm_deb(404) = &HCE8A8F34: asm_deb(405) = &H3310EAC1
    asm_deb(406) = &H4008FAC: asm_deb(407) = &HCA8A0000
    asm_deb(408) = &H8F8433: asm_deb(409) = &H8A000008
    asm_deb(410) = &H8F9C33CE: asm_deb(411) = &HC00&
    asm_deb(412) = &H824548B: asm_deb(413) = &H5A330233
    asm_deb(414) = &H8723304: asm_deb(415) = &H8D0C6A33
    asm_deb(416) = &H54891052: asm_deb(417) = &HBF8D0824
    asm_deb(418) = &H1000&: asm_deb(419) = &H1C89D08B
    asm_deb(420) = &H24748924: asm_deb(421) = &H8BCA8A04
    asm_deb(422) = &HCE8A8F04: asm_deb(423) = &H8B10EAC1
    asm_deb(424) = &H4008F9C: asm_deb(425) = &HCA8A0000
    asm_deb(426) = &H8FB48B: asm_deb(427) = &H8A000008
    asm_deb(428) = &H8BD58BCE: asm_deb(429) = &HC008FAC
    asm_deb(430) = &HCA8A0000: asm_deb(431) = &H8A8F2C33
    asm_deb(432) = &H10EAC1CE: asm_deb(433) = &H8F8433
    asm_deb(434) = &H8A000004: asm_deb(435) = &H8F9C33CA
    asm_deb(436) = &H800&: asm_deb(437) = &HB433CE8A
    asm_deb(438) = &HC008F: asm_deb(439) = &H24148B00
    asm_deb(440) = &H1C33CA8A: asm_deb(441) = &HC1CE8A8F
    asm_deb(442) = &HB43310EA: asm_deb(443) = &H4008F
    asm_deb(444) = &H33CA8A00: asm_deb(445) = &H8008FAC
    asm_deb(446) = &HCE8A0000: asm_deb(447) = &H8F8433
    asm_deb(448) = &H8B00000C: asm_deb(449) = &H8A042454
    asm_deb(450) = &H8F3433CA: asm_deb(451) = &HEAC1CE8A
    asm_deb(452) = &H8FAC3310: asm_deb(453) = &H400&
    asm_deb(454) = &H8433CA8A: asm_deb(455) = &H8008F
    asm_deb(456) = &H33CE8A00: asm_deb(457) = &HC008F9C
    asm_deb(458) = &H548B0000: asm_deb(459) = &H2330824
    asm_deb(460) = &H33045A33: asm_deb(461) = &H6A330872
    asm_deb(462) = &H10528D0C: asm_deb(463) = &H8245489
    asm_deb(464) = &H8B0CC483: asm_deb(465) = &H8914244C
    asm_deb(466) = &H4598901: asm_deb(467) = &H89087189
    asm_deb(468) = &H5D5B0C69: asm_deb(469) = &HC0335E5F
    asm_deb(470) = &H10C2&
    
    Replace_CryptFunc
End Sub

Private Sub Replace_CryptFunc()
  Dim OldProtection As Long, pMyself As Long
  
    'Diese nderung hat bei mir die Ausfhrungszeit auf 2/3 reduziert
    'Die Entschlsselung lief zuerst ohne Replace
  
    pMyself = ad(AddressOf Rijndael_EncryptBlock)
    
    VirtualProtect ByVal pMyself, 7, PAGE_EXECUTE_READWRITE, OldProtection
    RtlMoveMemory ByVal pMyself, &HB8, 1  ' mov eax, PointerToCode
    RtlMoveMemory ByVal pMyself + 1, VarPtr(asm_reb(0)), 4
    RtlMoveMemory ByVal pMyself + 5, &HE0FF&, 2 ' jmp eax
    VirtualProtect ByVal pMyself, 7, OldProtection, OldProtection
    
    OldProtection = 0
    
    pMyself = ad(AddressOf Rijndael_DecryptBlock)
    
    VirtualProtect ByVal pMyself, 7, PAGE_EXECUTE_READWRITE, OldProtection
    RtlMoveMemory ByVal pMyself, &HB8, 1  ' mov eax, PointerToCode
    RtlMoveMemory ByVal pMyself + 1, VarPtr(asm_deb(0)), 4
    RtlMoveMemory ByVal pMyself + 5, &HE0FF&, 2 ' jmp eax
    VirtualProtect ByVal pMyself, 7, OldProtection, OldProtection
End Sub

Private Function ad(ByVal x As Long) As Long
    ad = x
End Function

Public Function mul(a As Byte, b As Byte) As Byte
    If a <> 0 And b <> 0 Then
      mul = Potenz((Logarithmus(a) + Logarithmus(b)) Mod 255)
    Else
      mul = 0
    End If
End Function

Private Function Inv(a As Long) As Long
  Dim i As Long
    If a < 2 Then Inv = a: Exit Function
    
    Inv = Potenz(255 - Logarithmus(a))
End Function

Private Function fwd_affine(a As Long) As Long
  Dim tmp As Long

    tmp = a Xor shl(a, 1) Xor shl(a, 2) Xor shl(a, 3) Xor shl(a, 4)
    tmp = tmp Xor shr(tmp, 8) Xor &H63&
    
    fwd_affine = tmp And &HFF&
End Function

Private Function inv_affine(a As Long) As Long
  Dim tmp As Long

    tmp = shl(a, 1) Xor shl(a, 3) Xor shl(a, 6)
    tmp = tmp Xor shr(tmp, 8) Xor &H5&
    
    inv_affine = tmp And &HFF&
End Function

Public Sub KeyExpansion(cipher() As Byte, blockbits As Long)
  Dim i As Long, xi_1(3) As Byte
    
    'Durch die Optimierung vorbestimmt
    Const Lk As Long = 4
    Const Lb As Long = 4
    Const Lr As Long = 10
    
    'ReDim key(3, Lb * (Lr + 1) - 1)
    
    For i = 0 To Lk - 1
      key(0, i) = cipher(i * 4)
      key(1, i) = cipher(i * 4 + 1)
      key(2, i) = cipher(i * 4 + 2)
      key(3, i) = cipher(i * 4 + 3)
    Next i
    
    For i = Lk To Lb * (Lr + 1) - 1
      If i Mod Lk = 0 Then
        xi_1(0) = Substitution(key(1, i - 1)) Xor rc(Int(i / Lk))
        xi_1(1) = Substitution(key(2, i - 1))
        xi_1(2) = Substitution(key(3, i - 1))
        xi_1(3) = Substitution(key(0, i - 1))
      Else
        xi_1(0) = key(0, i - 1)
        xi_1(1) = key(1, i - 1)
        xi_1(2) = key(2, i - 1)
        xi_1(3) = key(3, i - 1)
      End If
      
      key(0, i) = xi_1(0) Xor key(0, i - Lk)
      key(1, i) = xi_1(1) Xor key(1, i - Lk)
      key(2, i) = xi_1(2) Xor key(2, i - Lk)
      key(3, i) = xi_1(3) Xor key(3, i - Lk)
    Next i
End Sub

Public Sub InvKeyExpansion(cipher() As Byte, blockbits As Long)
  Dim x As Long, y As Long, n As Long
  
    KeyExpansion cipher, blockbits
    
    'Durch die Optimierung vorbestimmt
    'ReDim ikey(UBound(key, 1), UBound(key, 2))
    For n = 10 To 0 Step -1
      For y = 0 To 3
        For x = 0 To 3
          ikey(x, y + (10 - n) * 4) = key(x, y + n * 4)
        Next x
      Next y
    Next n
    
    InvMixColumns ikey, 4, 39
End Sub
