Attribute VB_Name = "RijndaelTest"
Option Explicit

Private Const EXIT_ON_ERROR As Boolean = True

Public Sub Do_Tests()
    VariableKey_Test
    VariableText_Test
    Random_Test
End Sub

Private Sub VariableKey_Test()
  Dim bkey() As Byte, block(3, 3) As Byte
  Dim i As Byte, n As Byte, c As Long, k As String
  
    Log "Test mit variablen Schlssel wird gestartet"
    Log "Block- und Schlssellnge: 128 Bit"
  
    k = String(16, "0")
    
    c = 1
    Mid$(k, c, 1) = "8"
    
    Do
      bkey = StrConv(k, vbFromUnicode)
      'KeyExpansion bkey, 128
      InvKeyExpansion bkey, 128
      
      For i = 0 To 3
        For n = 0 To 3
          block(i, n) = 0
        Next n
      Next i
      
      Rijndael_EncryptBlock block(0, 0), key(0, 0), t(0, 0), 0&
      Rijndael_DecryptBlock block(0, 0), ikey(0, 0), t2(0, 0), 0&
      
      For i = 0 To 3
        For n = 0 To 3
          If block(i, n) <> 0 Then
            Log "Fehler aufgetreten, VariableKey-Test"
            PrintBlock block
            If EXIT_ON_ERROR Then Stop
          End If
        Next n
      Next i
      
      If Mid$(k, c, 1) = "1" Then
        Mid$(k, c, 1) = "0"
        c = c + 1
        If c > 16 Then Exit Do
        Mid$(k, c, 1) = "8"
      Else
        If Mid$(k, c, 1) = "2" Then
          Mid$(k, c, 1) = "1"
        Else
          If Mid$(k, c, 1) = "4" Then
            Mid$(k, c, 1) = "2"
          Else
            If Mid$(k, c, 1) = "8" Then
              Mid$(k, c, 1) = "4"
            Else
              Stop
            End If
          End If
        End If
      End If
    Loop
    
    Log CStr(c * 4 - 4) & " Schlssel ausprobiert"
    Log "Test erfolgreich beendet"
    Log "#####################################"
End Sub

Private Sub VariableText_Test()
  Dim bkey() As Byte, block() As Byte, block2() As Byte
  Dim i As Byte, n As Byte, c As Long, b As String
  
    Log "Test mit variablem Plaintext wird gestartet"
    Log "Block- und Schlssellnge: 128 Bit"
  
    bkey = StrConv(String(16, "0"), vbFromUnicode)
    'KeyExpansion bkey, 128
    InvKeyExpansion bkey, 128
    
    b = String(16, "0")
    c = 1
    Mid$(b, c, 1) = "8"
    
    Do
      StringToBlock b, block, 128
      StringToBlock b, block2, 128

      Rijndael_EncryptBlock block(0, 0), key(0, 0), t(0, 0), 0&
      Rijndael_DecryptBlock block(0, 0), ikey(0, 0), t2(0, 0), 0&
      
      For i = 0 To 3
        For n = 0 To 3
          If block(i, n) <> block2(i, n) Then
            Log "Fehler aufgetreten, VariableText-Test"
            PrintBlock block
            PrintBlock block2
            If EXIT_ON_ERROR Then Stop
          End If
        Next n
      Next i
      
      If Mid$(b, c, 1) = "1" Then
        Mid$(b, c, 1) = "0"
        c = c + 1
        If c > 16 Then Exit Do
        Mid$(b, c, 1) = "8"
      Else
        If Mid$(b, c, 1) = "2" Then
          Mid$(b, c, 1) = "1"
        Else
          If Mid$(b, c, 1) = "4" Then
            Mid$(b, c, 1) = "2"
          Else
            If Mid$(b, c, 1) = "8" Then
              Mid$(b, c, 1) = "4"
            Else
              Stop
            End If
          End If
        End If
      End If
    Loop
    
    Log CStr(c * 4 - 4) & " Blcke ausprobiert"
    Log "Test erfolgreich beendet"
    Log "#####################################"
End Sub

Private Sub Random_Test()
  Dim bkey() As Byte, block() As Byte, block2() As Byte
  Dim i As Long, k As String, n As Long
  
    Log "Verschiedene Tests werden ausgefhrt"
    Log "Block- und Schlssellnge: 128 Bit"
    
    Log "Schlssel und Block identisch: = Null"
    ReDim bkey(15)
    ReDim block(3, 3): ReDim block2(3, 3)
    
    'KeyExpansion bkey, 128
    InvKeyExpansion bkey, 128
    Rijndael_EncryptBlock block(0, 0), key(0, 0), t(0, 0), 0&
    Rijndael_DecryptBlock block(0, 0), ikey(0, 0), t2(0, 0), 0&
    Check_Block block, block2
    
    Log "Schlssel und Block identisch: Zufallswerte"
    k = ""
    For i = 1 To 16
      k = k & Chr$(Rnd * 255)
    Next i
    bkey = StrConv(k, vbFromUnicode)
    StringToBlock k, block, 128
    Copy_Block block, block2
    
    'KeyExpansion bkey, 128
    InvKeyExpansion bkey, 128
    Rijndael_EncryptBlock block(0, 0), key(0, 0), t(0, 0), 0&
    Rijndael_DecryptBlock block(0, 0), ikey(0, 0), t2(0, 0), 0&
    Check_Block block, block2
    
    Log "Schlssel und Block zufllig festgelegt"
    For i = 1 To Rnd * 1000 + 1000
      k = ""
      For n = 1 To 16
        k = k & Chr$(Rnd * 255)
      Next n
      bkey = StrConv(k, vbFromUnicode)
      
      Set_Random block
      Copy_Block block, block2
      
      'KeyExpansion bkey, 128
      InvKeyExpansion bkey, 128
      Rijndael_EncryptBlock block(0, 0), key(0, 0), t(0, 0), 0&
      Rijndael_DecryptBlock block(0, 0), ikey(0, 0), t2(0, 0), 0&
      Check_Block block, block2
    Next i
    
    Log "Test erfolgreich beendet"
    Log "#####################################"
End Sub

Private Sub Check_Block(block() As Byte, block2() As Byte)
  Dim i As Long, n As Long
  
    For i = 0 To 3
      For n = 0 To 3
        If block(i, n) <> block2(i, n) Then
          Log "Fehler aufgetreten: Random_Test"
          PrintBlock block
          PrintBlock block2
          If EXIT_ON_ERROR Then Stop
        End If
      Next n
    Next i
End Sub

Private Sub Set_Random(block() As Byte)
  Dim i As Long, n As Long
    
    For i = 0 To 3
      For n = 0 To 3
        block(i, n) = Int(Rnd * 255)
      Next n
    Next i
End Sub

Private Sub Copy_Block(block() As Byte, block2() As Byte)
  Dim i As Long, n As Long
    
    For i = 0 To 3
      For n = 0 To 3
        block2(i, n) = block(i, n)
      Next n
    Next i
End Sub
